# Copyright 2023 The JAX Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

import jax

# TODO(micky774): Remove after deprecating ddof-->correction in jnp.std and
# jnp.var
def std(x, /, *, axis=None, correction=0.0, keepdims=False):
  """Calculates the standard deviation of the input array x."""
  return jax.numpy.std(x, axis=axis, ddof=correction, keepdims=keepdims)


def var(x, /, *, axis=None, correction=0.0, keepdims=False):
  """Calculates the variance of the input array x."""
  return jax.numpy.var(x, axis=axis, ddof=correction, keepdims=keepdims)
